/*
Copyright (c) AppDynamics, Inc., and its affiliates
2015
All Rights Reserved
 */
/* global process, require, exports */
'use strict';

var Metric = require('./metric').Metric;
var ProxyLauncher = require('./proxy-launcher').ProxyLauncher;
var ProxyTransport = require('./proxy-transport').ProxyTransport;
var InstanceInfoSender = require('./instance-info-sender').InstanceInfoSender;
var TransactionReporter = require('./transaction-reporter').TransactionReporter;

function LibProxy(agent) {
  this.agent = agent;
  this.proxyLauncher = new ProxyLauncher(agent);
  this.proxyTransport = new ProxyTransport(agent);
  this.instanceInfoSender = new InstanceInfoSender(agent);
  this.transactionReporter = new TransactionReporter(agent);

  agent.Metric = Metric;
}

exports.LibProxy = LibProxy;

LibProxy.prototype.init = function() {
  this.proxyTransport.init();
  this.proxyLauncher.init();
  this.proxyLauncher.start();
  this.instanceInfoSender.init();
  this.transactionReporter.init();
};
